<script src="kp.js" type="text/javascript"></script>
<script>
/*
Daemon King -> Daemon 6.66 -> ...
Presenta
Il Poker del suo amato cagnolino King

Trovate commenti sia italiani e inglesi, quelli inglesi sono sulle cose piu importanti!
*/

// tasti rapidi
var kA=65;
var kS=83;
var kD=68;
var kF=70;
var kG=71;
var k1=49;
var k2=50;
var k3=51;
var k4=52;
var k5=53;
var BACKSPACE=8;

var timer=null;
var money=100; // soldi iniziali
var canhold=0; // posso fare l'hold sulle carte
var debug=0;
var first=1; // prima giocata

// first setup
var cards=new Array(0,0,0,0,0);
var cards_symbols=new Array(0,0,0,0,0);

var as=0,bs=0,cs=0,ds=0,es=0; // buffer 
var ha=0,hb=0,hc=0,hd=0,he=0; // hold cards

// symbols
var symbols = new Array(10, 100, 1000, 10000); // cuori, fiori, picche, quadri
var path = new Array("cuori","fiori","picche","quadri");

// statements
var is_pair=0;
var is_doublepair=0;
var is_tris=0;
var is_scale=0;
var is_color=0;
var is_full=0;
var is_poker=0;
var is_royalscale=0;

// --------------------------------------------------------------------------------------------------------------


function rnd(n,min,max)
{
var temp=n;
var casuale=0;

	while(temp>=13) // minimizzo il termine
	{
	temp=temp/2;
	if(temp>=13) n=temp; else break;
	}

	while(1)
	{
	casuale=Math.round(Math.random()*n);
	if(casuale >= min && casuale <= max) break;
	}

return casuale ;
}


function getCards(a,b,c,d,e)
{
if(!a) cards[0]=rnd(money+52,1,13);
if(!b) cards[1]=rnd(money+51,1,13);
if(!c) cards[2]=rnd(money+50,1,13);
if(!d) cards[3]=rnd(money+49,1,13);
if(!e) cards[4]=rnd(money+48,1,13);

// set symbol for each card
if(!a){ as=rnd(8,0,3); cards_symbols[0]=symbols[as]; }
if(!b){ bs=rnd(7,0,3); cards_symbols[1]=symbols[bs]; }
if(!c){ cs=rnd(6,0,3); cards_symbols[2]=symbols[cs]; }
if(!d){ ds=rnd(5,0,3); cards_symbols[3]=symbols[ds]; }
if(!e){ es=rnd(4,0,3); cards_symbols[4]=symbols[es]; }

// difficolta, rendo il gioco piu difficile(non faccio pagare facile, detto in gergo)
/*
vale solo nel dai carte.
*/
if(!a && !b && !c && !d && !e)
{

	if(money >= 300 && money <= 600) // piccola difficolta
	{
			if( isPair(cards) )
				cards[0]=rnd(money+47,1,13);
	else 	if( isDoublePair(cards) )
				cards[1]=rnd(money+46,1,13);
	else	if( isTris(cards) )
				cards[2]=rnd(money+45,1,13);
	}

	else	
	if(money >= 800 && money <= 1600) //  media difficolta
	{
			if( isPair(cards) )
			{
				cards[0]=rnd(money+47,1,13);
				cards[1]=rnd(money+46,1,13);
			}
	else 	if( isDoublePair(cards) )
			{
				cards[2]=rnd(money+45,1,13);
				cards[3]=rnd(money+44,1,13);
			}
	else	if( isTris(cards) )
			{
				cards[0]=rnd(money+43,1,13);
				cards[2]=rnd(money+42,1,13);
				cards[4]=rnd(money+41,1,13);
			}
	}

	else	
	if(money >= 2200 ) // alta difficolta
	{
			if( isPair(cards) )
			{
			
				cards[0]=rnd(money+47,1,13);
				cards[1]=rnd(money+47,1,13);
				cards[2]=rnd(money+47,1,13);
			}
	else 	if( isDoublePair(cards) )
			{
				cards[3]=rnd(money+46,1,13);
				cards[4]=rnd(money+46,1,13);
				cards[0]=rnd(money+46,1,13);
			}
	else	if( isTris(cards) )
			{
				cards[1]=rnd(money+45,1,13);
				cards[2]=rnd(money+45,1,13);
				cards[3]=rnd(money+45,1,13);
			}
	else	if( isPoker(cards) )
			{
				cards[4]=rnd(money+44,1,13);
				cards[0]=rnd(money+44,1,13);
				cards[1]=rnd(money+44,1,13);
			}
			
// cambio anche i semi
as=rnd(8,0,3); cards_symbols[0]=symbols[as];
bs=rnd(7,0,3); cards_symbols[1]=symbols[bs];
cs=rnd(6,0,3); cards_symbols[2]=symbols[cs];
ds=rnd(5,0,3); cards_symbols[3]=symbols[ds];
es=rnd(4,0,3); cards_symbols[4]=symbols[es];
	}

} // fine difficolt


// difficolta in runtime(evito di far prendere facile agli hold)

	if(money >= 400 && money <= 800) // piccola difficolta
	{
			if( isPair(cards) )
				if(!a) cards[0]=rnd(money+47,1,13);
	else 	if( isDoublePair(cards) )
				if(!b) cards[1]=rnd(money+46,1,13);
	else	if( isTris(cards) )
				if(!c) cards[2]=rnd(money+45,1,13);
	}

	else	
	if(money >= 1000 && money <= 2000) //  media difficolta
	{
			if( isPair(cards) )
			{
				if(!a) cards[0]=rnd(money+47,1,13);
				if(!b) cards[1]=rnd(money+46,1,13);
			}
	else 	if( isDoublePair(cards) )
			{
				if(!c) cards[2]=rnd(money+45,1,13);
				if(!d) cards[3]=rnd(money+44,1,13);
			}
	else	if( isTris(cards) )
			{
				if(!a) cards[0]=rnd(money+43,1,13);
				if(!c) cards[2]=rnd(money+42,1,13);
				if(!e) cards[4]=rnd(money+41,1,13);
			}
	}

	else	
	if(money >= 2400 ) // alta difficolta
	{
			if( isPair(cards) )
			{
			
				if(!a) cards[0]=rnd(money+47,1,13);
				if(!b) cards[1]=rnd(money+47,1,13);
				if(!c) cards[2]=rnd(money+47,1,13);
			}
	else 	if( isDoublePair(cards) )
			{
				if(!d) cards[3]=rnd(money+46,1,13);
				if(!e) cards[4]=rnd(money+46,1,13);
				if(!a) cards[0]=rnd(money+46,1,13);
			}
	else	if( isTris(cards) )
			{
				if(!b) cards[1]=rnd(money+45,1,13);
				if(!c) cards[2]=rnd(money+45,1,13);
				if(!d) cards[3]=rnd(money+45,1,13);
			}
	else	if( isPoker(cards) )
			{
				if(!e) cards[4]=rnd(money+44,1,13);
				if(!a) cards[0]=rnd(money+44,1,13);
				if(!b) cards[1]=rnd(money+44,1,13);
			}
	}


if(debug)
{}

// draw new card
if(!a){ document.getElementById("a").src="res/"+path[as]+"["+cards[0]+"].jpg"; }
if(!b){ document.getElementById("b").src="res/"+path[bs]+"["+cards[1]+"].jpg"; }
if(!c){ document.getElementById("c").src="res/"+path[cs]+"["+cards[2]+"].jpg"; }
if(!d){ document.getElementById("d").src="res/"+path[ds]+"["+cards[3]+"].jpg"; }
if(!e){ document.getElementById("e").src="res/"+path[es]+"["+cards[4]+"].jpg"; }
}


// main game control
function gameControl()
{
if(document.getElementById("play").value=="PLAY")
	document.getElementById("play").value="CAMBIO!";
else
	document.getElementById("play").value="PLAY";

	if(money>0)
	{
		if(!canhold)
			{
			money-=20;
			if(first) first=0; else check(cards,cards_symbols);			
			updateMoney();
			noHold();
			}	

	// ottengo le carte
	getCards(ha,hb,hc,hd,he);
	if(!canhold) canhold=1; else canhold=0;
	} else alert("Game over");
}


function updateMoney(){ document.getElementById("cash").value=money; }


function Hold(card)
{
	if(canhold)
	{
	document.getElementById("h"+card+"").style.display="block";
	
	     if(card=="a") if(!ha) ha=1; else { document.getElementById("ha").style.display="none"; ha=0; }
	else if(card=="b") if(!hb) hb=1; else { document.getElementById("hb").style.display="none"; hb=0; }
	else if(card=="c") if(!hc) hc=1; else { document.getElementById("hc").style.display="none"; hc=0; }
	else if(card=="d") if(!hd) hd=1; else { document.getElementById("hd").style.display="none"; hd=0; }
	else if(card=="e") if(!he) he=1; else { document.getElementById("he").style.display="none"; he=0; }
	} else alert("Non posso bloccare la carta perch  stata gia effettuata la giocata.");
}


function noHold()
{
document.getElementById("ha").style.display="none";
document.getElementById("hb").style.display="none";
document.getElementById("hc").style.display="none";
document.getElementById("hd").style.display="none";
document.getElementById("he").style.display="none";
ha=0;
hb=0;
hc=0;
hd=0;
he=0;
}


function setCombo(pair, doublepair, tris, scale, color, full, poker, royalscale)
{
is_pair=pair;
is_doublepair=doublepair;
is_tris=tris;
is_scale=scale;
is_color=color;
is_full=full;
is_poker=poker;
is_royalscale=royalscale;
}


function check(arrayA,arrayB)
{

// anti bug-full
var valuepair=isPair(arrayA);
if(valuepair!=0) is_pair=1;

is_doublepair = isDoublePair(arrayA);
is_tris = isTris(arrayA);
is_scale = isScale(arrayA);
is_color = isColor(arrayB);
is_full = (is_pair && is_tris); // risolvo bug
is_poker = isPoker(arrayA);
is_royalscale = (is_scale && is_color);

is_pair=0; // restore is_pair
if(valuepair==1 || valuepair>9) is_pair=1;

if(debug)
{
alert("PAIR="+is_pair+"\nBut origin is: "+valuepair);
alert("DOUBLE PAIR="+is_doublepair);
alert("TRIS="+is_tris);
alert("SCALE="+is_scale);
alert("COLOR="+is_color);
alert("FULL="+is_full);
alert("POKER="+is_poker);
alert("ROYAL SCALE="+is_royalscale);
}

	// logic win, game brain detect best win
	if( (is_pair + is_doublepair + is_tris + is_scale + is_color + is_full + is_poker + is_royalscale) > 1)
	{
	// detect best win
		
		if(is_royalscale)
			setCombo(0,0,0,0,0,0,0,1);
		
		else if(is_poker)
			setCombo(0,0,0,0,0,0,1,0);
		
		else if(is_full)
			setCombo(0,0,0,0,0,1,0,0);

		else if(is_color)
			setCombo(0,0,0,0,1,0,0,0);
		
		else if(is_scale)
			setCombo(0,0,0,1,0,0,0,0);
			
		else if(is_tris)
			setCombo(0,0,1,0,0,0,0,0);
		
		else if(is_doublepair)
			setCombo(0,1,0,0,0,0,0,0);
			
		else if(is_pair)
			setCombo(1,0,0,0,0,0,0,0);
	}
	
		if(is_pair)
		{
		showKing("pair",800);
		money+=20;
		}
	
		else if(is_doublepair)
		{
		showKing("doublepair",800);
		money+=40;
		}
	
		else if(is_tris)
		{
		showKing("tris",1000);
		money+=60;
		}
		
		else if(is_scale)
		{
		showKing("scale",1200);
		money+=80;
		}
		
		else if(is_color)
		{
		showKing("color",1500);
		money+=120;
		}
		
		else if(is_full)
		{
		showKing("full",2000);
		money+=200;
		}
		
		else if(is_poker)
		{ 
		showKing("poker",2000);
		money+=400;
		}
		
		else if(is_royalscale)
		{
		showKing("royalscale",2500);
		money+=1000;
		}
		
// empty all
setCombo(0,0,0,0,0,0,0,0);
}


// funzioni di King


function showKing(kind,delay)
{
document.getElementById("king").src="res/happy_"+kind+".gif";
document.getElementById("king").style.visibility="visible";
timer=setTimeout("setDefaultKing()",delay);
}

function setDefaultKing()
{
if(timer) clearTimeout(timer);
document.getElementById("king").style.visibility="hidden";
document.getElementById("king").style.top=(screen.availHeight)-(document.getElementById("king").height)*2;
document.getElementById("king").style.left=(screen.availWidth/2)-(document.getElementById("king").width)/2;
document.getElementById("king").src="loading.gif";
}


// how to play
function howtoplay()
{
alert("King Poker\nVersione 0.4b\nBy Daemon King 6.66\n\nUn gioco come il vecchio VIDEOPOKER. Le regole sono le stesse, puoi bloccare le tue carte cliccandoci sopra(prima di effettuare la giocata). Ricordo che in alcuni VIDEOPOKER la coppia era valida dal J in poi, qui si  fatta un eccezzione, la coppia vale da 10 in poi. Il resto  identico!\n\nBUON DIVERTIMENTO.");
}


function virtualkey(VK)
{
	switch(VK)
	{
	case k1: Hold("a"); break;
	case k2: Hold("b"); break;
	case k3: Hold("c"); break;
	case k4: Hold("d"); break;
	case k5: Hold("e"); break;
	
	case kA: Hold("a"); break;
	case kS: Hold("b"); break;
	case kD: Hold("c"); break;
	case kF: Hold("d"); break;
	case kG: Hold("e"); break;
	
	case BACKSPACE: gameControl(); break;
	}
}


</script>

<html>
<title>King Poker 0.4b</title>
<body bgcolor="black" background="res/background.gif" onkeyup="virtualkey(event.keyCode)">
<font face="Arial black" color="white" size="4">

<img src="res/loading.gif" width="500" height="350" style="filter: alpha(opacity=95); -moz-opacity: 0.95;  position: absolute; left: 0px; top: 0px; z-index: 1000;" name="king" id="king">

<center>
<marquee><img src="res/logo.jpg" style="cursor: help" onclick="howtoplay()"></marquee><br><br>

<table cellspacing="0" cellpadding="4" border="0" bgcolor="yellow" width="80%" style="border: medium solid red; color: white; font-size: 40px">

<tr align="center" valign="top" style="cursor: pointer">
	<!-- Prima carta -->
	<td><img id="a" name="a" onclick="Hold(this.id)" src="res/empty.jpg"></td>
	
	<!-- Seconda carta -->
	<td><img id="b" name="b" onclick="Hold(this.id)" src="res/empty.jpg"></td>
	
	<!-- Terza carta -->
	<td><img id="c" name="c" onclick="Hold(this.id)" src="res/empty.jpg"></td>
	
	<!-- Quarta carta -->
	<td><img id="d" name="d" onclick="Hold(this.id)" src="res/empty.jpg"></td>
	
	<!-- Quinta carta -->
	<td><img id="e" name="e" onclick="Hold(this.id)" src="res/empty.jpg"></td>
</tr>

<tr align="center" valign="top" style="height: 1px">
	<!-- HOLD Prima carta -->
	<td><img id="ha" name="ha" src="res/hold.bmp" style="display: none; position: relative;"></td>
	
	<!-- HOLD Seconda carta -->
	<td><img id="hb" name="hb" src="res/hold.bmp" style="display: none; position: relative;"></td>
	
	<!-- HOLD Terza carta -->
	<td><img id="hc" name="hc" src="res/hold.bmp" style="display: none; position: relative;"></td>
	
	<!-- HOLD Quarta carta -->
	<td><img id="hd" name="hd" src="res/hold.bmp" style="display: none; position: relative;"></td>
	
	<!-- HOLD Quinta carta -->
	<td><img id="he" name="he" src="res/hold.bmp" style="display: none; position: relative;"></td>
</tr>

<tr bgcolor="brown" valign="middle">
	<td colspan="4" align="left">
	
	<input name="cash" id="cash" type="text" readonly style="color: yellow; font-size: 50px; border: none; background-color: red; width: 200px; font-family: Comic Sans MS; border: medium solid black; text-align: center;">
	</td>
	
	<td align="right" colspan="1">
	<input name="play" id="play" type="button" value="PLAY" onclick="gameControl()" style="cursor: pointer; background-color: green; color: yellow; font-size: 35px; width: 100%; height: 100%; border: medium dashed darkblue; font-family: Comic Sans MS">
	</td>
</tr>

</table>

</center>

</font>
</body>
</html>

<script>
// basic setups
setDefaultKing();
document.getElementById("cash").value=money;
</script>

