window.onload = init;


var pistaG=new Array();
var mosse;
var tabellone = new Array();
var t;

function init(){
	tabellone = document.getElementById("tabellone");
	for( ii = 0; ii < 4; ii++)
		tabellone.rows[ii].cells[1].innerHTML = "_____";
	newGame();
}

function newGame(){
	creaTable();
	standard();
	mescola(); // commentare per avere la pista non mescolata e quindi provare a fare una vincita facile facile =)
}

function creaTable(){
	document.getElementById("mesk").onclick = mescola;
	var str="<table id='pista' onclick='gioco(event)'>";
	for(i=0; i<4; i++){
		str+="<tr>";
		for(a=0; a<4; a++)
		{
			var result = (a+1)+(i*4);
			str+="<td> "+result+" </td>";
		}
		str+="</tr>";
	}
	str+="</table>";
	document.getElementById("Pista").innerHTML=str;
	pistaG = document.getElementById("pista");
}

function gioco(e) {
	if (window.event) {
		e = window.event;
		cella = e.srcElement;
	} else {
		cella = e.target;
	} 
	
	var x = cella.parentNode.rowIndex+1;
	var y = cella.cellIndex+1;
	if(Math.sqrt(Math.pow(pistaG["x"]-x, 2)+Math.pow(pistaG["y"]-y, 2))==1) {
		if(mosse == 0) time(); // fai partire il tempo che ha appena comminciato a giocare.
		var num = cella.firstChild.nodeValue;
		cella.innerHTML = "";
		pistaG.rows[pistaG["x"]-1].cells[pistaG["y"]-1].innerHTML = num;
		pistaG["x"]=x;
		pistaG["y"]=y;
		tabellone.rows[1].cells[1].innerHTML = ++mosse;
		vinto();
	}
}

function vinto() {
	var y = 0;
	var win = true;

	while (y < 15 && win){ // si fa un controllo se sono in ordine
		win = (pistaG.rows[Math.floor((y)/4)].cells[y%4].innerHTML == (y+1))
		y++;
	}
	if (win) {// se si vince si impostano i record e si azzerano i contatori di tempo e mosse. E si parte con il nuovo gioco !!!!
		if(tabellone.rows[0].cells[1].innerHTML == "_____" || tabellone.rows[0].cells[1].innerHTML > mosse )
			tabellone.rows[0].cells[1].innerHTML = mosse;
		if(tabellone.rows[2].cells[1].innerHTML == "_____" || tabellone.rows[2].cells[1].innerHTML > t )
			tabellone.rows[2].cells[1].innerHTML  = t;
		newGame();	
		window.clearTimeout(tt);	
	}
}


// viene creato un array con degli interi da 1 - 15 ed in modalita random viene inserito ognuno di questi numeri nel campo da gioco
// per poi essere eliminato dal array, e cosi via fino a quando l'array  vuoto e quindi fino a quando abbiamo riempito ogni casella della pista
// con un valore.
function mescola() {
	var inter = new Array(); //viene creato l'array
	for(i = 1; i < 16; i++)
		inter[i] = i;
	var y = 0;
	while (y < 15){
		pistaG.rows[Math.floor((y)/4)].cells[y%4].innerHTML = inter.splice(Math.floor(1+Math.random()*(15-y)),1); y++;
	}
	standard();
	window.clearTimeout(tt);	
} 

// Imposta i contatori, i vuoalizzatori di valori e la pedina bianca
function standard() {
	mosse = 0;
	t = -1;
	pistaG["x"] = 4;
	pistaG["y"] = 4;
	pistaG.rows[3].cells[3].innerHTML = "";
	tabellone.rows[1].cells[1].innerHTML = "_____";
	tabellone.rows[3].cells[1].innerHTML = "_____";
}

function time(){
	tabellone.rows[3].cells[1].innerHTML = ++t;
	tt = window.setTimeout('time()',1000);	
}